package goaml.mvc.model;

public class SimulationModel extends AbstractModel {

	public enum TimeUnit {
		HOUR, DAY;
	}

	public final int DEFAULT_DURATION = 1;
	public final double DEFAULT_INTEGRALSTEP = 1.0;

	private String XMLPath;
	private String CSVPath;
	private String driverPath;
	private int nbrOfTimeSteps;
    private static double integralStep;
	private TimeUnit timeUnit;

	public SimulationModel() {
		this.XMLPath = "";
		this.CSVPath = "";
		this.driverPath = "";
		this.nbrOfTimeSteps = DEFAULT_DURATION;
		integralStep = DEFAULT_INTEGRALSTEP;
		this.timeUnit = TimeUnit.HOUR;
	}

	// Getters and Setters
	public String getXMLPath() {
		return this.XMLPath;
	}

	public void setXMLPath(final String path) {
		if (this.XMLPath.equals(path)) {
			return;
		}
		this.XMLPath = path;
		setChanged();
		notifyObservers();
	}

	public String getCSVPath() {
		return this.CSVPath;
	}

	public void setCSVPath(final String path) {
		if (this.CSVPath.equals(path)) {
			return;
		}
		this.CSVPath = path;
		setChanged();
		notifyObservers();
	}

	public String getDriverPath() {
		return this.driverPath;
	}

	public void setDriverPath(final String path) {
		if (this.driverPath.equals(path)) {
			return;
		}
		this.driverPath = path;
		setChanged();
		notifyObservers();
	}

	public static double getIntegralStep() {
		return integralStep;
	}

	public void setIntegralStep(final double integralStep) {
		if (SimulationModel.integralStep == integralStep) {
			return;
		}
		SimulationModel.integralStep = integralStep;
		setChanged();
		notifyObservers();
	}
	
	public int getNbrOfTimeSteps() {
		return this.nbrOfTimeSteps;
	}

	public void setNbrOfTimeSteps(final int nbrOfTimeSteps) {
		if (this.nbrOfTimeSteps == nbrOfTimeSteps) {
			return;
		}
		this.nbrOfTimeSteps = nbrOfTimeSteps;
		setChanged();
		notifyObservers();
	}

	public TimeUnit getTimeUnit() {
		return this.timeUnit;
	}

	public void setTimeUnit(final TimeUnit timeUnit) {
		if (this.timeUnit == timeUnit) {
			return;
		}
		this.timeUnit = timeUnit;
		setChanged();
		notifyObservers();
	}

}
